/// State-based PNCounter
export class PNCounter {
    _increments;
    _decrements;
    constructor(increments, decrements) {
        this._increments = increments;
        this._decrements = decrements;
    }
    value() {
        return this._increments.value() - this._decrements.value();
    }
    increments() {
        return this._increments;
    }
    decrements() {
        return this._decrements;
    }
    increment(nodeId, amount) {
        this._increments.increment(nodeId, amount);
    }
    decrement(nodeId, amount) {
        this._decrements.increment(nodeId, amount);
    }
    compare(peerCounter) {
        return (this._increments.compare(peerCounter.increments()) &&
            this._decrements.compare(peerCounter.decrements()));
    }
    merge(peerCounter) {
        this._increments.merge(peerCounter.increments());
        this._decrements.merge(peerCounter.decrements());
    }
}
